const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Relatorios_mensaisDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorios_mensais = await db.relatorios_mensais.create(
      {
        id: data.id || undefined,

        mes_referencia: data.mes_referencia || null,
        resumo: data.resumo || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await relatorios_mensais.setObra(data.obra || null, {
      transaction,
    });

    await relatorios_mensais.setClientes(data.clientes || null, {
      transaction,
    });

    return relatorios_mensais;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const relatorios_mensaisData = data.map((item, index) => ({
      id: item.id || undefined,

      mes_referencia: item.mes_referencia || null,
      resumo: item.resumo || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const relatorios_mensais = await db.relatorios_mensais.bulkCreate(
      relatorios_mensaisData,
      { transaction },
    );

    // For each item created, replace relation files

    return relatorios_mensais;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const relatorios_mensais = await db.relatorios_mensais.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.mes_referencia !== undefined)
      updatePayload.mes_referencia = data.mes_referencia;

    if (data.resumo !== undefined) updatePayload.resumo = data.resumo;

    updatePayload.updatedById = currentUser.id;

    await relatorios_mensais.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await relatorios_mensais.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await relatorios_mensais.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return relatorios_mensais;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorios_mensais = await db.relatorios_mensais.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of relatorios_mensais) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of relatorios_mensais) {
        await record.destroy({ transaction });
      }
    });

    return relatorios_mensais;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const relatorios_mensais = await db.relatorios_mensais.findByPk(
      id,
      options,
    );

    await relatorios_mensais.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await relatorios_mensais.destroy({
      transaction,
    });

    return relatorios_mensais;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const relatorios_mensais = await db.relatorios_mensais.findOne(
      { where },
      { transaction },
    );

    if (!relatorios_mensais) {
      return relatorios_mensais;
    }

    const output = relatorios_mensais.get({ plain: true });

    output.obra = await relatorios_mensais.getObra({
      transaction,
    });

    output.clientes = await relatorios_mensais.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.resumo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('relatorios_mensais', 'resumo', filter.resumo),
        };
      }

      if (filter.mes_referenciaRange) {
        const [start, end] = filter.mes_referenciaRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            mes_referencia: {
              ...where.mes_referencia,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            mes_referencia: {
              ...where.mes_referencia,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.relatorios_mensais.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('relatorios_mensais', 'resumo', query),
        ],
      };
    }

    const records = await db.relatorios_mensais.findAll({
      attributes: ['id', 'resumo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['resumo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.resumo,
    }));
  }
};
